require 'drb/drb'
require 'drb/eq'
require 'rinda/ring'
require 'thread'

class RingEcho
  include DRbUndumped
  def initialize(name)
    @name = name
  end
  
  def echo(str)
    "#{@name}: #{str}"
  end
end

def ring_lookup
  queue = Queue.new

  Thread.new do
    finger = Rinda::RingFinger.new
    finger.lookup_ring do |ts|
      queue.push(ts)
    end
    queue.push(nil)
  end

  ts = queue.pop
  raise('RingNotFound') if ts.nil?
  ts
end

DRb.start_service

renewer = Rinda::SimpleRenewer.new

finder = Rinda::RingFinger.new
ts = finder.loopup_ring_any
ts.read_all([:name, :RingEcho, nil, nil]).each do |tuple|
  p tuple[2]
  puts tuple[2].echo('Hello, World') rescue nil
end
ts.write([:name, :RingEcho, RingEcho.new(DRb.uri), ''], renewer)

$stdin.gets

